#include <stdio.h>
#include <stdlib.h>
#include "sample.h"

main(argc,argv)
int argc;
char **argv;
{
   int taps;
   int highpass = 0;
   int i,p=0;
   sample s,*array;
   int al,ar;
   if(argc!=2) {
      fprintf(stderr,"Usage: %s <# taps>\n",argv[0]);
      exit(999);
   }
   taps = atoi(argv[1]);
   if(taps<0) {
      taps = -taps;
      highpass = 1;
   }
   array = malloc(taps*sizeof(sample));
   while(0<fread(&s,sizeof(sample),1,stdin)) {
      array[p] = s;
      p = (p+1)%taps;
      al = ar = 0;
      for(i=0;i<taps;i++) {
         al += array[i].left;
         ar += array[i].right;
      }
      al = al / taps;
      ar = ar / taps;
      if(highpass) {
         s.left -= al;
         s.right -= ar;
      } else {
         s.left = al;
         s.right = ar;
      }
      fwrite(&s,sizeof(sample),1,stdout);
   }
}
