#include <sys/types.h>
#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>

#include <stropts.h>
#include <sys/conf.h>

#include <sys/filio.h>
#include <sys/audioio.h>

#define BUFSIZE 1024

short buf[BUFSIZE];

main()
{
  audio_info_t ainfo;
  int type;
  int fd;
  int r,val,bp;

  fd = open("/dev/audio",O_WRONLY);
  if(fd < 0)  {
     perror("audio open");
     exit(999);
  }

  if(ioctl(fd, AUDIO_GETINFO, &ainfo) == -1) {
    perror("AUDIO_GETINFO");
    exit(999);
  }

  ainfo.play.sample_rate = 44100;

  ainfo.play.port = AUDIO_SPEAKER;
  //ainfo.play.port = AUDIO_HEADPHONE;
  //ainfo.play.port = AUDIO_LINE_OUT;

  ainfo.play.channels = 2;

  ainfo.play.gain = 5;

  ainfo.play.encoding = AUDIO_ENCODING_LINEAR;
  ainfo.play.precision = 16;

  if(ioctl(fd, AUDIO_SETINFO, &ainfo) == -1) {
     perror("AUDIO_SETINFO");
     exit(999);
  }
  bp = 0;
  do {
     short *p;
     while(bp<BUFSIZE) {
        int r = fread(buf+bp,2,BUFSIZE-bp,stdin);
        if(r<=0) break;
        bp += r;
     }
     write(fd,buf,bp*2);
     bp = 0;
  } while(!feof(stdin));
  close(fd);
}
